{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load active_tag %}
{% load md2 %}

{% block title %}Reportes inspecciones de calidad{% endblock %}

{% block pagelevelcss %}
<link href="{% static 'theme/plugins/c3/c3.min.css' %}" rel="stylesheet" type="text/css">
{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  <li><a href="#">Reportes inspecciones de calidad</a></li>
{% endblock breadcrumbs %}

{% block page %}
	<!-- begin page-header -->
	<h1 class="page-header">Inspecciones <!--small>Ver llamadas por motivo</small--></h1>
	<!-- end page-header -->


  

   
    <div id="service-status-app">
		<!-- begin row -->
		<div class="row">
			<!-- begin col-12 -->
			<div class="col-xl-12 ui-sortable">
				<!-- begin panel -->
				<div class="panel panel-inverse" data-sortable-id="ui-general-1">
					<!-- begin panel-heading -->
					<div class="panel-heading ui-sortable-handle">
						<h4 class="panel-title">Reporte de Inspecciones de Calidad</h4>
						<div class="panel-heading-btn">
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
						</div>
					</div>
					<!-- end panel-heading -->
					<!-- begin panel-body -->
					<div class="panel-body">
						<div class="row mb-3">
							<div class="col-sm-6">
								<ul class="nav nav-pills m-b-3">
									<li class="nav-item">
										<a href="javascript:;" class="nav-link active" data-type="agent" v-on:click="changeReportType('agent')">Agente</a>
									</li>
									<li class="nav-item">
										<a href="javascript:;" class="nav-link" data-type="typing" v-on:click="changeReportType('typing')">Tipificación</a>
									</li>
								</ul>
							</div>
							<div class="col-sm-6">
								<button id="export-pdf" class="btn btn-primary btn-sm pull-right ml-1" v-on:click="generatePdf()">Exportar PDF</button>
								<button id="export-excel" class="btn btn-indigo btn-sm pull-right ml-1" v-on:click="generateExcel()">Exportar Excel</button>
							</div>
						</div>					
						<div class="row justify-content-left">
							<div class="field-panel">
								<div class="field-panel-heading">
									<label>Desde:</label>
								</div>
								<div class="field-panel-body">
									<input type="date" class="form-control m-b-5" v-model="initiald">
								</div>
							</div>
							<div class="field-panel">
								<div class="field-panel-heading">
									<label>Hasta:</label>
								</div>
								<div class="field-panel-body">
									<input type="date" class="form-control m-b-5" v-model="finald">
								</div>
							</div>
							<div class="field-panel" data-type="agent">
								<div class="field-panel-heading">
									<label>Agente:</label>
								</div>
								<div class="field-panel-body">
									<v-select v-model="selectedAgent" :options="agentOptions" :searchable="false"></v-select>
								</div>
							</div>
							<div class="field-panel d-none" data-type="typing">
								<div class="field-panel-heading">
									<label>Tipo:</label>
								</div>
								<div class="field-panel-body">
									<v-select v-model="selectedTyping" :options="typingOptions" :searchable="false"></v-select>
								</div>
							</div>
							<div class="field-panel d-none" data-type="typing">
								<div class="field-panel-heading">
									<label>Categoría:</label>
								</div>
								<div class="field-panel-body">
									<v-select v-model="selectedCategory" :options="categoryOptions" :searchable="false"></v-select>
								</div>
							</div>
							<div class="field-panel d-none" data-type="typing">
								<div class="field-panel-heading">
									<label>SubCategoría:</label>
								</div>
								<div class="field-panel-body">
									<v-select v-model="selectedSubcategory" :options="subcategoryOptions"></v-select>
								</div>
							</div>
						</div>
						<div class="row mt-3">
							<div class="col-md-12 col-lg-6">
								<img :src="url ? url : ''" width="100%"/>
							</div>
					
							<div class="col-md-12 col-lg-6">
								{% verbatim %}
									<h4>Datos de llamadas</h4>
									<h5 class="text-muted">{{ message }}</h5>
									<table class="table table-bordered table-striped">
										<tr>
											<td colspan="2" v-if="active == 'agent'">
												AGENTE
											</td>
											<td colspan="2" v-else>
												TIPIFICACIÓN
											</td>
										</tr>
										<tr v-for="(record, key, index) in snapshots">
											<td v-if="record.qty &lt; 0">{{ key }}</td>
											<td class="text-center" v-if="record.qty &lt; 0">TOTAL</td>
											<td v-if="record.qty >= 0">{{ key }}</td>
											<td class="text-center" v-if="record.qty >= 0">{{ record.qty }}</td>
										</tr>
									</table>
								{% endverbatim %}
							</div>
						</div>
					</div>
					<!-- end panel-body -->
				</div>
				<!-- end panel -->
			</div>
			<!-- end col -->
		</div>
		<!-- end row -->
	</div> 
	<!-- service-status-app -->


{% endblock %}

{% block pageleveljs %}
<script type="text/javascript">
    //active menu
    document.getElementById("reports_menu").classList.add("active");
    //active submenu item
    document.getElementById("callsqareport_item").classList.add("active");
</script>

<script src="{% static 'js/vue' %}"></script>
<script src="{% static 'js/vue-resource' %}"></script>
<script src="{% static 'js/vue-select' %}"></script>
<script src="{% static 'js/lodash.min.js' %}"></script>

<script>
	
    get = function(obj, key) {
		return key.split(".").reduce(function(o, x) {
	    	return (typeof o == "undefined" || o === null) ? o : o[x];
		}, obj);
    }

  	Vue.component('v-select', VueSelect.VueSelect);

  	// Register a global custom directive called v-focus
  	Vue.directive('focus', {
  		// When the bound element is inserted into the DOM...
  		inserted: function (el) {
  			// Focus the element
  			el.focus()
  		}
  	});

  	var service_status_app = new Vue({
    	el: '#service-status-app',
      	data: {
			message: null,
	  		initiald: "{{ first_of_month }}",
	  		finald: "{{ last_of_month }}",
	  		snapshots: {},
			active: "agent",
			agentOptions: [{value: null, label: "Todos"},{% for agent in agents %}{value: {{ agent.pk }}, label: "{{ agent }}"},{% endfor %}],
	  		selectedAgent: {value: null, label: "Todos"},
	  		typingOptions: [{% for typing in typings %}{value: {{ typing.0 }}, label: "{{ typing.1 }}"},{% endfor %}],
	  		selectedTyping: {value: {{ typings.0.0 }}, label: "{{ typings.0.1 }}"},
	  		categoryOptions: [{% for category in categories %}{value: {{ category.0 }}, label: "{{ category.1 }}"},{% endfor %}],
	  		selectedCategory: {value: {{ categories.0.0 }}, label: "{{ categories.0.1 }}"},
	  		subcategoryOptions: [{% for subcategory in subcategories %}{value: {{ subcategory.0 }}, label: "{{ subcategory.1 }}"},{% endfor %}],
	  		selectedSubcategory: {value: {{ subcategories.0.0 }}, label: "{{ subcategories.0.1 }}"},
	  		url: "",
      	},
      	watch: {
	  		initiald: function(newInitialD) {
	    		if (newInitialD) {
		  			this.message = 'Refrescando datos...';
	      		}
	      		this.refreshData();
	  		},
			finald: function(newFinalD) {
				if (newFinalD) {
					this.message = 'Refrescando datos...';
				}
				this.refreshData();
			},
			selectedAgent: function(newAgent) {
				if (newAgent) {
					this.message = 'Refrescando datos...';
				}
				this.refreshData();
			},
			selectedTyping: function(newTyping) {
				if (newTyping) {
					this.categoryOptions = [{value: 0, label: "-----"}]
					this.selectedCategory = {value: 0, label: "-----"}
					this.subcategoryOptions = [{value: 0, label: "-----"}]
					this.selectedSubcategory = {value: 0, label: "-----"}
					this.getCategory(newTyping);
					this.message = 'Refrescando datos...';
				}
				this.refreshData();
			},
			selectedCategory: function(newCategory) {
				if (newCategory) {
					this.subcategoryOptions = [{value: 0, label: "-----"}]
					this.selectedSubcategory = {value: 0, label: "-----"}
					this.getSubcategory(newCategory);
					this.message = 'Refrescando datos...';
				}
				this.refreshData();
			},
			selectedSubcategory: function(newSubcategory) {
				if (newSubcategory) {
					this.message = 'Refrescando datos...';
				}
				this.refreshData();
			}
		},
		mounted: function () {
			this.refreshData();
		},
      	methods: {
			refreshData: _.debounce(
				function() {
					this.active = document.querySelector('a.nav-link.active').dataset.type;
					var link = '';
					if (this.active == 'agent'){
						link = '/reports/call-qa-table-ajax/?type=agent&initiald='+this.initiald+'&finald='+this.finald+'&agent='+get(this.selectedAgent, 'value');
					}else{
						link = '/reports/call-qa-table-ajax/?type=typing&initiald='+this.initiald+'&finald='+this.finald+'&typing='+get(this.selectedTyping, 'value')+'&category='+get(this.selectedCategory, 'value')+'&subcategory='+get(this.selectedSubcategory, 'value');
					}
					this.$http.get(link).then(response => {
						var unordered = response.body.snapshot_data;
						var ordered = {};
						if (this.active == 'agent'){
							Object.keys(unordered).sort().forEach(function(key) {
								ordered[key] = unordered[key];
							});
						}else{
							ordered = unordered
						}
						this.snapshots = ordered;
						this.message = null;
						this.url = response.body.graph;
					});
				},
				300
			),
			changeReportType: function(type){
				document.querySelectorAll('a.nav-link').forEach(function(elem){
					elem.classList.remove('active');
					if (type == elem.dataset.type){
						elem.classList.add('active');
					}
				});

				var agentPanel = document.querySelector('div[data-type="agent"]');
				var typingPanel = document.querySelectorAll('div[data-type="typing"]');
			
				if (type == 'agent'){
					agentPanel.classList.remove('d-none');
					typingPanel.forEach(function(panel){
						panel.classList.add('d-none');
					});
				}else{
					agentPanel.classList.add('d-none');
					typingPanel.forEach(function(panel){
						panel.classList.remove('d-none');
					});
					this.selectedAgent = {value: null, label: "Todos"}
				}
				this.refreshData();
			},
			generateExcel: function(){
				this.active = document.querySelector('a.nav-link.active').dataset.type;
				var link = '';
				if (this.active == 'agent'){
					link = '/export-call-qa-excel/?type=agent&initiald='+this.initiald+'&finald='+this.finald+'&agent='+get(this.selectedAgent, 'value');
				}else{
					link = '/export-call-qa-excel/?type=typing&initiald='+this.initiald+'&finald='+this.finald+'&typing='+get(this.selectedTyping, 'value')+'&category='+get(this.selectedCategory, 'value')+'&subcategory='+get(this.selectedSubcategory, 'value');
				}
				window.open(link, "_blank");
			},
			generatePdf: function(){
				this.active = document.querySelector('a.nav-link.active').dataset.type;
				var link = '';
				if (this.active == 'agent'){
					link = '/export-call-qa-pdf/?type=agent&initiald='+this.initiald+'&finald='+this.finald+'&agent='+get(this.selectedAgent, 'value');
				}else{
					link = '/export-call-qa-pdf/?type=typing&initiald='+this.initiald+'&finald='+this.finald+'&typing='+get(this.selectedTyping, 'value')+'&category='+get(this.selectedCategory, 'value')+'&subcategory='+get(this.selectedSubcategory, 'value');
				}
				window.open(link, "_blank");
			},
			getCategory: function(parent){
				let parent_value = get(parent, "value");
				if (parent_value > 0){
					let link = "/customers/typing/childs/?parent="+parent_value;
					this.$http.get(link).then(response => {
						var category = [{value: null, label: "-----"}];
						response.body.records.forEach(function(key) {
							category.push({value: key.ID, label: key.name})
						});
						this.categoryOptions = category;
					});
				}else{
					this.categoryOptions = [{value: null, label: "-----"}]
				}				
			},
			getSubcategory: function(parent){
				let parent_value = get(parent, "value");
				if (parent_value > 0){
					let link = "/customers/typing/childs/?parent="+parent_value;
					this.$http.get(link).then(response => {
						var subcategory = [{value: null, label: "-----"}];
						response.body.records.forEach(function(key) {
							subcategory.push({value: key.ID, label: key.name})
						});
						this.subcategoryOptions = subcategory;
					});
				}else{
					this.subcategoryOptions = [{value: null, label: "-----"}]
				}				
			}
      	}
	  });
	  
	  $("input[type='search']").each(function(){
		  $(this).addClass("d-none");
	  });

</script>

{% endblock %}
